package de.intevation.flys.client.shared.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;


public class Capabilities implements Serializable {

    protected String title;
    protected String onlineResource;
    protected String fees;
    protected String accessConstraints;

    protected ContactInformation contactInformation;

    protected List<WMSLayer> layers;


    public Capabilities() {
        layers = new ArrayList<WMSLayer>();
    }


    /**
     * @param fees
     * @param accessConstraints
     * @param layers
     */
    public Capabilities(
        String             title,
        String             onlineResource,
        ContactInformation contactInformation,
        String             fees,
        String             accessConstraints,
        List<WMSLayer>     layers
    ) {
        this.title              = title;
        this.onlineResource     = onlineResource;
        this.contactInformation = contactInformation;
        this.fees               = fees;
        this.accessConstraints  = accessConstraints;
        this.layers             = layers;
    }


    public String getTitle() {
        return title;
    }


    public String getOnlineResource() {
        return onlineResource;
    }


    public ContactInformation getContactInformation() {
        return contactInformation;
    }


    public String getFees() {
        return fees;
    }


    public String getAccessConstraints() {
        return accessConstraints;
    }


    public List<WMSLayer> getLayers() {
        return layers;
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("--- Capabilities ---\n");
        sb.append("Title:.............. " + title + "\n");
        sb.append("Online Resource:.... " + onlineResource + "\n");
        sb.append("Contact Information: " + contactInformation + "\n");
        sb.append("Fees:............... " + fees + "\n");
        sb.append("Access Constraints:. " + accessConstraints + "\n");
        sb.append("Layers: ");

        for (WMSLayer layer: layers) {
            sb.append("   - " + layer + "\n");
        }

        return sb.toString();
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
